Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle Application Development Framework Model and Business Components Java API Reference 10g Release 3 (10.1.3) B16005-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.jbo.server.java.util
Interface Collection

All Known Subinterfaces:
  List, Set

All Known Implementing Classes:
  AbstractCollection, AbstractList, AbstractSet, ArrayList, ArraySet

public interface Collection

The root interface in the collection hierarchy. A Collection represents a group of Objects, known as its elements. Bags (unordered collections that may contain duplicate elements) implement this interface directly, rather than implementing one of its "subinterfaces", List or Set.

The interfaces that comprise the collection hierarchy are designed to allow manipulation of collections in an implementation-independent fashion. This allows for interoperability among unrelated APIs that take collections as input or return them as output. It reduces the effort in learning new APIs that would otherwise have their own collection interfaces, reduces the effort in designing such APIs, and fosters software reuse.

The collection hierarchy consists of four interfaces, the core collection intefaces. Two of these interfaces, Set and List, are children of the Collection interface; they add further constraints on the contracts imposed by the methods in this interface, as well as adding new methods. The final core collection interface, Map, is not a child of Collection, as it represents a mapping rather than a true collection.

All of the methods in Collection and the other core interfaces that modify the collection are labeled optional. Some implementations may not perform one or more of these operations, throwing a runtime exception,n UnsupportedOperationException, if they are attempted. Implementations should specify in their documentation which optional operations they support. Several terms are introduced to aid in this specification:

- Collections that do not support any modification operations (such as add, remove, clear) are referred to as unmodifiable. Collections that are not unmodifiable are referred to modifiable.
- Collections that additionally guarantee that no change in the Collection will ever be observable via "query" operations (such as iterator, size, contains) are referred to as immutable. Collections that are not immutable are referred to as mutable.
- Lists that guarantee that their size will remain constant even though the elements may change are referred to as fixed-size. Lists that are not fixed-size are referred to as variable-size.

Some implementations may restrict what elements (or in the case of Maps, keys and values) may be stored. Possible restrictions include requiring elements to:

- be of a particular type.
- be comparable to other elements in the collection.
- be non-null.
- obey some arbitrary predicate.

Attempting to add an element that violates an implementation's restrictions will result in a runtime exception, typically a ClassCastException, an IllegalArgumentException or a NullPointerException. Attempting to remove or test for such an element may result in such an exception, though some "restricted collections" may permit this usage.

All general-purpose Collection implementation classes should provide two "standard" constructors: a void (no arguments) constructor, which creates an empty Collection, and a constructor with a single argument of type Collection, which creates a new Collection with the same elements as its argument. In effect, the latter constructor allows the user to copy any Collection, producing an equivalent Collection of the desired implementation type. Similarly, all general-purpose Map implementations should provide a void (no arguments) constructor and a constructor that takes a single argument of type Map. There is no way to enforce these recommendations (as interfaces cannot contain constructors) but all of the general-purpose Collection and Map implementations in the JDK comply.

Collection implementation classes typically have names of the form <Implementation><Interface>. Set implementations in the JDK include HashSet and ArraySet. List implementations include ArrayList, LinkedList and Vector. Map implementations include HashMap, TreeMap, ArrayMap, and Hashtable. (The JDK contains no class that implements Collection directly.) All of the JDK implementations with "new style" (<Implementation><Interface>) names are unsynchronized. The Collections class contains static factories that may be used to add synchronization to any unsynchronized collection.

The AbstractCollection, AbstractSet, AbstractList and AbstractSequentialList classes provide skeletal implementations of the core collection interfaces, to minimize the effort required to implement them. The Iterator, ListIterator, Comparable and Comparator interfaces provide the required "infrastructure."

Since:
  JDK1.2
See Also:
  `Set`, `List`, `Map`, `ArrayList`, `LinkedList`, `Vector`, `HashSet`, `ArraySet`, `HashMap`, `TreeMap`, `Hashtable`, `Collections`, `AbstractCollection`, `AbstractSet`, `AbstractList`, `AbstractSequentialList`, `AbstractMap`, `Iterator`, `ListIterator`, `Comparable`, `Comparator`, `UnsupportedOperationException`, `ConcurrentModificationException`

Method Summary
`boolean` | `add(java.lang.Object o)` Ensures that this Collection contains the specified element (optional operation).
`boolean` | `addAll(Collection c)` Adds all of the elements in the specified Collection to this Collection (optional operation).
`void` | `clear()` Removes all of the elements from this Collection (optional operation).
`boolean` | `contains(java.lang.Object o)` Returns true if this Collection contains the specified element.
`boolean` | `containsAll(Collection c)` Returns true if this Collection contains all of the elements in the specified Collection.
`boolean` | `equals(java.lang.Object o)` Compares the specified Object with this Collection for equality.
`int` | `hashCode()` Returns the hash code value for this Collection.
`boolean` | `isEmpty()` Returns true if this Collection contains no elements.
`Iterator` | `iterator()` Returns an Iterator over the elements in this Collection.
`boolean` | `remove(java.lang.Object o)` Removes a single instance of the specified element from this Collection, if it is present (optional operation).
`boolean` | `removeAll(Collection c)` Removes from this Collection all of its elements that are contained in the specified Collection (optional operation).
`boolean` | `retainAll(Collection c)` Retains only the elements in this Collection that are contained in the specified Collection (optional operation).
`int` | `size()` Returns the number of elements in this Collection.
`java.lang.Object[]` | `toArray()` Returns an array containing all of the elements in this Collection.

Method Detail

### size

    public int size()

  Returns the number of elements in this Collection.
  Since:
    JDK1.2

### isEmpty

    public boolean isEmpty()

  Returns true if this Collection contains no elements.
  Since:
    JDK1.2

### contains

    public boolean contains(java.lang.Object o)

  Returns true if this Collection contains the specified element. More formally, returns true if and only if this Collection contains at least one element `e` such that `(o==null ? e==null : o.equals(e))`.
  Parameters:
    `o` - element whose presence in this Collection is to be tested.
  Since:
    JDK1.2

### iterator

    public Iterator iterator()

  Returns an Iterator over the elements in this Collection. There are no guarantees concerning the order in which the elements are returned (unless this Collection is an instance of some class that provides a guarantee).
  Since:
    JDK1.2

### toArray

    public java.lang.Object[] toArray()

  Returns an array containing all of the elements in this Collection. If the Collection makes any guarantees as to what order its elements are returned by its Iterator, this method must return the elements in the same order. The returned array will be "safe" in that no references to it are maintained by the Collection. (In other words, this method must allocate a new array even if the Collection is backed by an Array). The caller is thus free to modify the returned array.

  This method acts as bridge between array-based and Collection-based APIs.

  Since:
    JDK1.2

### add

    public boolean add(java.lang.Object o)

  Ensures that this Collection contains the specified element (optional operation). Returns true if the Collection changed as a result of the call. (Returns false if this Collection does not permit duplicates and already contains the specified element.) Collections that support this operation may place limitations on what elements may be added to the Collection. In particular, some Collections will refuse to add null elements, and others will impose restrictions on the type of elements that may be added. Collection classes should clearly specify in their documentation any restrictions on what elements may be added.
  Parameters:
    `o` - element whose presence in this Collection is to be ensured.
  Returns:
    true if the Collection changed as a result of the call.
  Throws:
    `UnsupportedOperationException` - add is not supported by this Collection.
    `java.lang.ClassCastException` - class of the specified element prevents it from being added to this Collection.
    `java.lang.IllegalArgumentException` - some aspect of this element prevents it from being added to this Collection.
  Since:
    JDK1.2

### remove

    public boolean remove(java.lang.Object o)

  Removes a single instance of the specified element from this Collection, if it is present (optional operation). More formally, removes an element `e` such that `(o==null ? e==null : o.equals(e))`, if the Collection contains one or more such elements. Returns true if the Collection contained the specified element (or equivalently, if the Collection changed as a result of the call).
  Parameters:
    `o` - element to be removed from this Collection, if present.
  Returns:
    true if the Collection changed as a result of the call.
  Throws:
    `UnsupportedOperationException` - remove is not supported by this Collection.
  Since:
    JDK1.2

### containsAll

    public boolean containsAll(Collection c)

  Returns true if this Collection contains all of the elements in the specified Collection.
  Since:
    JDK1.2
  See Also:
    `contains(Object)`

### addAll

    public boolean addAll(Collection c)

  Adds all of the elements in the specified Collection to this Collection (optional operation). The behavior of this operation is undefined if the specified Collection is modified while the operation is in progress. (This implies that the behavior of this call is undefined if the the specified Collection is this Collection, and this Collection is nonempty.)
  Parameters:
    `c` - elements to be inserted into this Collection.
  Returns:
    true if this Collection changed as a result of the call.
  Throws:
    `UnsupportedOperationException` - addAll is not supported by this Collection.
    `java.lang.ClassCastException` - class of an element of the specified Collection prevents it from being added to this Collection.
    `java.lang.IllegalArgumentException` - some aspect of an element of the specified Collection prevents it from being added to this Collection.
  Since:
    JDK1.2
  See Also:
    `add(Object)`

### removeAll

    public boolean removeAll(Collection c)

  Removes from this Collection all of its elements that are contained in the specified Collection (optional operation). After this call returns, this Collection will contains no elements in common with the specified Collection.
  Parameters:
    `c` - elements to be removed from this Collection.
  Returns:
    true if this Collection changed as a result of the call.
  Throws:
    `UnsupportedOperationException` - removeAll is not supported by this Collection.
  Since:
    JDK1.2
  See Also:
    `remove(Object)`, `contains(Object)`

### retainAll

    public boolean retainAll(Collection c)

  Retains only the elements in this Collection that are contained in the specified Collection (optional operation). In other words, removes from this Collection all of its elements that are not contained in the specified Collection.
  Parameters:
    `c` - elements to be retained in this Collection.
  Returns:
    true if this Collection changed as a result of the call.
  Throws:
    `UnsupportedOperationException` - retainAll is not supported by this Collection.
  Since:
    JDK1.2
  See Also:
    `remove(Object)`, `contains(Object)`

### clear

    public void clear()

  Removes all of the elements from this Collection (optional operation). The Collection will be empty after this call returns (unless it throws an exception).
  Throws:
    `UnsupportedOperationException` - clear is not supported by this Collection.
  Since:
    JDK1.2

### equals

    public boolean equals(java.lang.Object o)

  Compares the specified Object with this Collection for equality.

  While Collection adds no stipulations to the general contract for Object.equals, programmers who implement Collection "directly" (in other words, create a class that is a Collection but is not a Set or a List) must exercise care if they choose to override Object.equals. It is not necessary to do so, and the simplest course of action is to rely on Object's implementation, but the implementer may wish to implement a "value comparison" in place of the default "reference comparison." (Lists and Sets mandate such value comparisons.)

  The general contract for Object.equals states that equals must be reflexive (in other words, `a.equals(b)` if and only if `b.equals(a)`). The contracts for List.equals and Set.equals state that Lists are only equal to other Lists, and Sets to other Sets. Thus, a custom equals method for a Collection that is neither a List nor a Set must return false when this Collection is compared to any List or Set.

  Parameters:
    `o` - Object to be compared for equality with this Collection.
  Returns:
    true if the specified Object is equal to this Collection.
  Since:
    JDK1.2
  See Also:
    `Object.equals(Object)`, `Set.equals(Object)`, `List.equals(Object)`

### hashCode

    public int hashCode()

  Returns the hash code value for this Collection. While Collection adds no stipulations to the general contract for Object.hashCode, programmers should take note that any class that overrides Object.equals must also override Object.hashCode, in order to satisfy the general contract for Object.hashCode. In particular, `c1.equals(c2)` implies that `c1.hashCode()==c2.hashCode()`.
  Since:
    JDK1.2
  See Also:
    `Object.hashCode()`, `Object.equals(Object)`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle Application Development Framework Model and Business Components Java API Reference 10g Release 3 (10.1.3) B16005-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1997, 2005, Oracle. All rights reserved.